#region Copyright Syncfusion Inc. 2001 - 2016
//
//  Copyright Syncfusion Inc. 2001 - 2016. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.GridHelperClasses;
using System.Data.SqlClient;
using System.Data.SqlServerCe;
using System.IO;
using DemoCommon.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using System.Text.RegularExpressions;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;

namespace Example
{
    /// <summary>
    /// Summary description for Form1.
    /// </summary>
    public partial class Form1 : GridDemoForm
    {
        TranslationEntity translationEntity;

        #region Constructor

        /// <summary>
        ///  Form Constructor.
        /// </summary>
        public Form1()
        {
            InitializeComponent();
            this.gridGroupingControl1.DataSource = GetTest();
            translationEntity = new TranslationEntity();
            translationEntity.InternalName = "InternalName";
            translationEntity.ExternalName = "ExternalName";
            translationEntity.DateUpdate = DateTime.Now;

            //Event hookup.
            this.gridGroupingControl1.TableControlCellClick += new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCellClick);
        }

        void gridGroupingControl1_TableControlCellClick(object sender, GridTableControlCellClickEventArgs e)
        {
            Record selectedRecord = this.gridGroupingControl1.Table.CurrentRecord;
            selectedRecord.SetValue("InternalName", translationEntity.InternalName);
            selectedRecord.SetValue("ExternalName", translationEntity.ExternalName);
            selectedRecord.SetValue("TranslationTypeEntity_Name", "entity");
            selectedRecord.SetValue("DateUpdate", translationEntity.DateUpdate);
            selectedRecord.SetValue("UserUpdate_Username", "username");
        }

        #endregion

        public IList<TranslationEntity> GetTest()
        {
            List<TranslationEntity> list = new List<TranslationEntity>();
            UserEntity userUpdate = new UserEntity();
            UserEntity userConclusion = new UserEntity();

            for(int i = 0; i < 50; i++)
            {
                TranslationTypeEntity typeEntity = new TranslationTypeEntity();
                typeEntity.Id = 12;
                typeEntity.Name = "Programa";
                
                userUpdate.Id = 12;
                userUpdate.Username = "vandeg";

                userConclusion.Id = 14;
                userConclusion.Username = "example";

                TranslationEntity entity = new TranslationEntity();
                entity.Id = 12;
                entity.InternalName = "Nome Interno " + i;
                entity.ExternalName = "Nome Externo" + i;
                entity.DateInclusion = DateTime.Now;
                entity.DateUpdate = DateTime.Now;
                entity.TranslationTypeEntity = typeEntity;
                entity.UserUpdate = userUpdate;
                entity.UserInclusion = userConclusion;

                list.Add(entity);
            }

            return list;
        }
    }

    public class TranslationEntity
    {
        public TranslationEntity()
        { }

        public int Id { get; set; }
        public string InternalName { get; set; }
        public string ExternalName { get; set; }
        public  UserEntity UserUpdate { get; set; }
        public DateTime DateInclusion { get; set; }
        public DateTime DateUpdate { get; set; }
        public TranslationTypeEntity TranslationTypeEntity { get; set; }
        public UserEntity UserInclusion { get; set; }
    }

    public class UserEntity
    {
        public UserEntity()
        {
        }
        public int Id { get; set; }
        public string Username { get; set; }
    }

    public class TranslationTypeEntity
    {
        public TranslationTypeEntity()
        {
        }
        public int Id { get; set; }
        public string Name { get; set; }
    }
}
